package com.bofeng.service;

import com.baomidou.mybatisplus.toolkit.IdWorker;
import com.bofeng.JwtHelper;
import com.bofeng.dao.UserOpenMapper;
import com.bofeng.entity.ParseCurrentOpenId;
import com.bofeng.entity.UserOpen;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import static com.bofeng.JwtHelper.getAuthHeader;

@Service
@Transactional(readOnly = true)
public class HomeService {

    @Autowired
    private UserService userService;
    @Autowired
    private UserOpenMapper userOpenMapper;

    @Transactional(rollbackFor = Exception.class, propagation = Propagation.REQUIRED)
    public void getUserOpen() {
        ParseCurrentOpenId wxToken = userService.currentWxUser();
        WxMpUser wxMpUser = wxToken.getWxMpUser();
        UserOpen user = userOpenMapper.selectByOpenId(wxMpUser.getOpenId());
        if (user == null) {
            // 账户没有注册,需要注册
            UserOpen userOpen = new UserOpen();
            userOpen.setUserId(IdWorker.getId());
            userOpen.setOpenId(wxMpUser.getOpenId());
            userOpen.setNickName(wxMpUser.getNickname());
            userOpen.setSexDesc(wxMpUser.getSexDesc());
            userOpen.setSex(wxMpUser.getSex());
            userOpen.setCity(wxMpUser.getCity());
            userOpen.setProvince(wxMpUser.getProvince());
            userOpen.setCountry(wxMpUser.getCountry());
            userOpen.setHeadImgUrl(wxMpUser.getHeadImgUrl());
            userOpen.setBeActive("Y");
            userOpenMapper.insert(userOpen);
        } else {
            Long userId = user.getUserId();
//            String userId = JwtHelper.getUserId();
            System.out.println(userId);
        }
    }

//    public void setUserInfo(UserOpen userOpen) {
//        JwtHelper.setU
//    }
}
